using System;

namespace Ejercicio1 {	
	class Principal {
		//Estructura Persona
		struct Person{
			public string nombre;
			public string apellido;
			public int edad;
			public int segsocial;
		}

		[STAThread]
		//Funcin Main
		static void Main() {
			Person[] Arreglo;
			int dimension=0,band=0;
			Console.Write("\t\tBienvenido al Programa de Estructura y Arreglo!\n");
			do{
				try{
					Console.Write("\nIngrese el tamao del Arreglo: ");
					dimension=int.Parse(Console.ReadLine());
					Arreglo = new Person[dimension];
					Principal.Llenar(Arreglo,dimension);
					Principal.Ordenar(Arreglo,dimension);
					Principal.Mostrar(Arreglo,dimension);
					Console.WriteLine("\nFin del Programa!");
					band=0;
				}catch(System.Exception e){
					Console.Write("\n"+e.Message.ToString()+"\n");
					band=1;
				}
			}while(band!=0);
			Console.Read ();
			return;
		}

		//Funcin llenar la Arreglo que contiene la estructura
		static void Llenar(Person[] Arreglo, int dimension){
			int band=0;
			do{
				try{
					for (int i=0;i<dimension;i++){
						Console.Write("\nIngrese el nombre de la persona: ");
						Arreglo[i].nombre=Console.ReadLine();
						Console.Write("\nIngrese el apellido de la persona: ");
						Arreglo[i].apellido=Console.ReadLine();
						Console.Write("\nIngrese la edad de la persona: ");
						Arreglo[i].edad=int.Parse(Console.ReadLine());
						Console.Write("\nIngrese el numero de seguro social de la persona: ");
						Arreglo[i].segsocial=int.Parse(Console.ReadLine());
					}
					band=0;
				}catch(System.FormatException e){
					Console.Write("\n"+e.Message.ToString());
					Console.Write("\nVuelva a introducir los datos!\n");
					band=1;
				}
			}while(band!=0);
			return;
		}

		//Funcin Ordenar Arreglo por mtodo Burbuja
		static void Ordenar(Person[] Arreglo,int dimension){
			Person[] Aux=new Person[1];
			for(int i=0;i<(dimension-1);i++){
				for (int j=i+1;j<dimension;j++){
					if(Arreglo[i].edad>Arreglo[j].edad){
						Aux[0]=Arreglo[i];
						Arreglo[i]=Arreglo[j];
						Arreglo[j]=Aux[0];
					}
				}
			}	
		}
		
		//Funcin mostrar resultados
		static void Mostrar(Person[] Arreglo,int dimension){
			for (int i=0;i<dimension;i++){
					Console.Write("\nEl nombre de la persona es: "+Arreglo[i].nombre);
					Console.Write("\nEl apellido de la persona es: "+Arreglo[i].apellido);
					Console.Write("\nLa edad de la persona es: "+Arreglo[i].edad);					
					Console.Write("\nEl numero de seguro social de la persona es: "+Arreglo[i].segsocial);
			}		
		}
	}
}
